## osmium-tool 1.14.0

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.5.0)

project(osmium VERSION 1.14.0 LANGUAGES CXX C)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")


#-----------------------------------------------------------------------------
#
#  Project version
#
#-----------------------------------------------------------------------------

# It is important that this setting remains before the "project" call.
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRel;Dev"
    CACHE STRING
    "List of available configuration types"
    FORCE)

set(AUTHOR "Jochen Topf <jochen@topf.org>")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

option(WITH_LZ4 "Build with lz4 support for PBF files" ON)

option(BUILD_TESTING "Build the tests" ON)


#-----------------------------------------------------------------------------
#
#  Find external dependencies
#
#-----------------------------------------------------------------------------

find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

find_package(Osmium 2.16.0 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})


if(WITH_LZ4)
    find_package(LZ4)

    if(LZ4_FOUND)
        message(STATUS "lz4 library found, compiling with it")
        add_definitions(-DOSMIUM_WITH_LZ4)
        include_directories(SYSTEM ${LZ4_INCLUDE_DIRS})
        list(APPEND OSMIUM_LIBRARIES ${LZ4_LIBRARIES})
    else()
        message(WARNING "lz4 library not found, compiling without it")
    endif()
else()
    message(STATUS "Building without lz4 support: Set WITH_LZ4=ON to change this")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "cppcheck" target that checks C++ code
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for cppcheck")
find_program(CPPCHECK cppcheck)

if(CPPCHECK)
    message(STATUS "Looking for cppcheck - found")
    set(CPPCHECK_OPTIONS --enable=warning,style,performance,portability,information,missingInclude)

    # cpp doesn't find system includes for some reason, suppress that report
    set(CPPCHECK_OPTIONS ${CPPCHECK_OPTIONS} --suppress=missingIncludeSystem)

    add_custom_target(cppcheck ${CPPCHECK} --std=c++14 ${CPPCHECK_OPTIONS} ${CMAKE_SOURCE_DIR}/src/*pp)
else()
    message(STATUS "Looking for cppcheck - not found")
    message(STATUS "  Build target 'cppcheck' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "iwyu" target to check headers
#  https://include-what-you-use.org/
#
#-----------------------------------------------------------------------------
find_program(IWYU_TOOL NAMES iwyu_tool iwyu_tool.py)

if(IWYU_TOOL)
    message(STATUS "Looking for iwyu_tool.py - found")
    add_custom_target(iwyu ${IWYU_TOOL} -p ${CMAKE_BINARY_DIR} -- --mapping_file=${CMAKE_SOURCE_DIR}/iwyu.imp)
else()
    message(STATUS "Looking for iwyu_tool.py - not found")
    message(STATUS "  Make target 'iwyu' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Decide which C++ version to use (Minimum/default: C++14).
#
#-----------------------------------------------------------------------------
if(NOT MSVC)
    if(NOT USE_CPP_VERSION)
        set(USE_CPP_VERSION c++14)
    endif()
    message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
    add_compile_options(-std=${USE_CPP_VERSION})
endif()


#-----------------------------------------------------------------------------
#
#  Compiler and Linker flags
#
#-----------------------------------------------------------------------------
if(MSVC)
    set(DEV_COMPILE_OPTIONS "/Ox")
    set(RWD_COMPILE_OPTIONS "/Ox /DNDEBUG")
else()
    set(DEV_COMPILE_OPTIONS "-O3 -g")
    set(RWD_COMPILE_OPTIONS "-O3 -g -DNDEBUG")
endif()

if(WIN32)
    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32)
endif()

set(CMAKE_CXX_FLAGS_DEV "${DEV_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during developer builds."
    FORCE)

set(CMAKE_EXE_LINKER_FLAGS_DEV ""
    CACHE STRING "Flags used by the linker during developer builds."
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_DEV
    CMAKE_EXE_LINKER_FLAGS_DEV
)

set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${RWD_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during RELWITHDEBINFO builds."
    FORCE)


#-----------------------------------------------------------------------------
#
#  Build Type
#
#-----------------------------------------------------------------------------

add_definitions(${OSMIUM_WARNING_OPTIONS})

# In 'Dev' mode: compile with very strict warnings and turn them into errors.
if(CMAKE_BUILD_TYPE STREQUAL "Dev")
    if(NOT MSVC)
        add_definitions(-Werror)
    endif()
endif()

# Force RelWithDebInfo build type if none was given
if(CMAKE_BUILD_TYPE)
    set(build_type ${CMAKE_BUILD_TYPE})
else()
    set(build_type "RelWithDebInfo")
endif()

set(CMAKE_BUILD_TYPE ${build_type}
    CACHE STRING
    "Choose the type of build, options are: ${CMAKE_CONFIGURATION_TYPES}."
    FORCE)

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")


#-----------------------------------------------------------------------------
#
#  Version
#
#-----------------------------------------------------------------------------

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#-----------------------------------------------------------------------------

configure_file(
    ${PROJECT_SOURCE_DIR}/osmium-wrapper.in
    ${PROJECT_BINARY_DIR}/osmium
)

include_directories(SYSTEM include)
include_directories(${PROJECT_BINARY_DIR}/src)

#-----------------------------------------------------------------------------

SET(OSMIUM_COMMANDS
    add-locations-to-ways
    apply-changes
    cat
    changeset-filter
    check-refs
    create-locations-index
    derive-changes
    diff
    export
    extract
    fileinfo
    getid
    getparents
    merge
    merge-changes
    query-locations-index
    removeid
    renumber
    show
    sort
    tags-count
    tags-filter
    time-filter
)

set(OSMIUM_SOURCE_FILES
    cmd.cpp
    cmd_factory.cpp
    id_file.cpp
    io.cpp
    util.cpp
    command_help.cpp
    option_clean.cpp
    export/export_format_json.cpp
    export/export_format_pg.cpp
    export/export_format_spaten.cpp
    export/export_format_text.cpp
    export/export_handler.cpp
    extract/extract_bbox.cpp
    extract/extract.cpp
    extract/extract_polygon.cpp
    extract/geojson_file_parser.cpp
    extract/geometry_util.cpp
    extract/osm_file_parser.cpp
    extract/poly_file_parser.cpp
    extract/strategy_complete_ways.cpp
    extract/strategy_complete_ways_with_history.cpp
    extract/strategy_simple.cpp
    extract/strategy_smart.cpp
)

foreach(_command ${OSMIUM_COMMANDS})
    string(REPLACE "-" "_" _ucmd ${_command})
    list(APPEND OSMIUM_SOURCE_FILES "command_${_ucmd}.cpp")
endforeach()

add_subdirectory(man)
add_subdirectory(src)


#-----------------------------------------------------------------------------
#
#  Tests
#
#-----------------------------------------------------------------------------

if(BUILD_TESTING)
    enable_testing()
    add_subdirectory(test)
endif()

#-----------------------------------------------------------------------------
#
#  Optional "clang-tidy" target
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-14 clang-tidy-13 clang-tidy-12 clang-tidy-11)

if(CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

    file(GLOB _unit_tests RELATIVE "${CMAKE_SOURCE_DIR}/src" "${CMAKE_SOURCE_DIR}/test/*/*.cpp")

    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${OSMIUM_SOURCE_FILES} ${_unit_tests}
        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/src"
    )
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()

#-----------------------------------------------------------------------------
#
#  Test install
#
#  Does a local install and checks that the files we expect to be installed
#  are installed and no extra files are installed. If this fails make sure
#  the list of files in cmake/test_install.cmake is correct. Only enables
#  if the WITH_EXTRA_TESTS option is set, because this test fails on some
#  platforms even if everything is correct.
#
#-----------------------------------------------------------------------------
option(WITH_EXTRA_TESTS "Run extra tests (usually only for developers)")
if(WITH_EXTRA_TESTS)
    add_test(NAME testinstall
             COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/test_install.cmake)
endif()

#-----------------------------------------------------------------------------

=== test/derive-changes/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - derive-changes
#
#-----------------------------------------------------------------------------

function(check_derive_changes _name _options _input1 _input2 _output)
    check_output(derive-changes ${_name} "derive-changes --generator=test -f osc ${_options} derive-changes/${_input1} derive-changes/${_input2}" "derive-changes/${_output}")
endfunction()

check_derive_changes(normal       ""                    input1.osm input2.osm output.osc)
check_derive_changes(keep_details "--keep-details"      input1.osm input2.osm output-keep-details.osc)
check_derive_changes(incr_version "--increment-version" input1.osm input2.osm output-incr-version.osc)

# Tests with input file which don't have the same amount of metadata fields:
# File 1 has all metadata fields, file 2 has only version fields.
check_derive_changes(new_file_only_versions "" input1.osm input2-only-versions.osm output-2-only-version.osc)

# File 1 has only version and timestamp fields, file 2 has only version fields.
check_derive_changes(version_timestamp_with_version "" input1-only-version-timestamp.osm input2-only-versions.osm output-2-only-version-timestamp.osc)

# File 1 has only version fields, file 2 has version and timestamp fields.
check_derive_changes(version_with_version_timestamp "" input1-only-version.osm input2-only-version-timestamp.osm output-2-version-with-version-timestamp.osc)

# File 1 has only version fields, file 2 has all metadata fields.
check_derive_changes(version_with_all "" input1-only-version.osm input2-all-with-relation.osm output-2-version-with-all.osc)

#-----------------------------------------------------------------------------

=== test/diff/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - diff
#
#-----------------------------------------------------------------------------

function(check_diff _name _options _input1 _input2 _output _return_code)
    check_output(diff ${_name} "diff ${_options} diff/${_input1} diff/${_input2}" "diff/${_output}" "${_return_code}")
endfunction()

check_diff(compact "" input1.osm input2.osm output-compact 1)

check_diff(compact-c "-c" input1.osm input2.osm output-compact-c 1)

check_diff(opl "-f opl" input1.osm input2.osm output.opl 1)

check_diff(opl-c "-f opl -c" input1.osm input2.osm output-c.opl 1)

check_diff(same "" input1.osm input1.osm output-same 0)

#-----------------------------------------------------------------------------

=== test/fileinfo/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - fileinfo
#
#-----------------------------------------------------------------------------

if(NOT WIN32)
    function(check_fileinfo _name _options _input _output)
        check_output(fileinfo ${_name} "fileinfo ${_options} fileinfo/${_input}" "fileinfo/${_output}")
    endfunction()

    check_fileinfo(fi1-extended "--extended --crc" fi1.osm fi1-result.txt)
endif()

#-----------------------------------------------------------------------------

add_test(NAME fileinfo-g-generator COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g header.option.generator)
set_tests_properties(fileinfo-g-generator PROPERTIES PASS_REGULAR_EXPRESSION "^testdata\n$")

add_test(NAME fileinfo-g-unknown-option COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g header.option.foo)
set_tests_properties(fileinfo-g-unknown-option PROPERTIES PASS_REGULAR_EXPRESSION "^$")

add_test(NAME fileinfo-g-fail COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi1.osm -g foobar)
set_tests_properties(fileinfo-g-fail PROPERTIES WILL_FAIL true)


#-----------------------------------------------------------------------------
# Test the metadata properties
#-----------------------------------------------------------------------------

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.version
add_test(NAME fileinfo-metadata-mixed-all-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.version)
set_tests_properties(fileinfo-metadata-mixed-all-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.timestamp
add_test(NAME fileinfo-metadata-mixed-all-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.timestamp)
set_tests_properties(fileinfo-metadata-mixed-all-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.all_objects.changeset
add_test(NAME fileinfo-metadata-mixed-all-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.all_objects.changeset)
set_tests_properties(fileinfo-metadata-mixed-all-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.version
add_test(NAME fileinfo-metadata-mixed-some-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.version)
set_tests_properties(fileinfo-metadata-mixed-some-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.timestamp
add_test(NAME fileinfo-metadata-mixed-some-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.timestamp)
set_tests_properties(fileinfo-metadata-mixed-some-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.changeset
add_test(NAME fileinfo-metadata-mixed-some-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.changeset)
set_tests_properties(fileinfo-metadata-mixed-some-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.uid
add_test(NAME fileinfo-metadata-mixed-some-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.uid)
set_tests_properties(fileinfo-metadata-mixed-some-uid PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file has objects with only version+timestamp and objects with all metadata attributes.
# searching for metadata.some_objects.user
add_test(NAME fileinfo-metadata-mixed-some-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi2.osm -e -g metadata.some_objects.user)
set_tests_properties(fileinfo-metadata-mixed-some-user PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.version
add_test(NAME fileinfo-metadata-homogenous-all-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.version)
set_tests_properties(fileinfo-metadata-homogenous-all-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.timestamp
add_test(NAME fileinfo-metadata-homogenous-all-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.timestamp)
set_tests_properties(fileinfo-metadata-homogenous-all-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.changeset
add_test(NAME fileinfo-metadata-homogenous-all-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.changeset)
set_tests_properties(fileinfo-metadata-homogenous-all-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.uid
add_test(NAME fileinfo-metadata-homogenous-all-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.uid)
set_tests_properties(fileinfo-metadata-homogenous-all-uid PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.all_objects.user
add_test(NAME fileinfo-metadata-homogenous-all-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.all_objects.user)
set_tests_properties(fileinfo-metadata-homogenous-all-user PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.version
add_test(NAME fileinfo-metadata-homogenous-some-version COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.version)
set_tests_properties(fileinfo-metadata-homogenous-some-version PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.timestamp
add_test(NAME fileinfo-metadata-homogenous-some-timestamp COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.timestamp)
set_tests_properties(fileinfo-metadata-homogenous-some-timestamp PROPERTIES PASS_REGULAR_EXPRESSION "^yes\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.changeset
add_test(NAME fileinfo-metadata-homogenous-some-changeset COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.changeset)
set_tests_properties(fileinfo-metadata-homogenous-some-changeset PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.uid
add_test(NAME fileinfo-metadata-homogenous-some-uid COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.uid)
set_tests_properties(fileinfo-metadata-homogenous-some-uid PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

# The input file contains only objects with version+timestamp.
# searching for metadata.some_objects.user
add_test(NAME fileinfo-metadata-homogenous-some-user COMMAND osmium fileinfo ${CMAKE_SOURCE_DIR}/test/fileinfo/fi3.osm -e -g metadata.some_objects.user)
set_tests_properties(fileinfo-metadata-homogenous-some-user PROPERTIES PASS_REGULAR_EXPRESSION "^no\n$")

#-----------------------------------------------------------------------------

=== test/formats/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - formats
#
#-----------------------------------------------------------------------------

function(check_formats _name _input _format _output)
    check_output(formats ${_name} "cat --generator=test --output-header xml_josm_upload=false -f ${_format} ${PROJECT_SOURCE_DIR}/test/formats/${_input}" "formats/${_output}")
endfunction()

#-----------------------------------------------------------------------------

# empty file (no objects)
check_formats(emptyxx   empty.osm xml empty.osm)
check_formats(emptyxo   empty.osm opl empty.osm.opl)
check_formats(emptyxp   empty.osm pbf                                              empty.osm.pbf)
check_formats(emptyxpd  empty.osm pbf,pbf_dense_nodes=false                        empty-nodensenodes.osm.pbf)
check_formats(emptyxpc  empty.osm pbf,pbf_compression=none                         empty-nocompression.osm.pbf)
check_formats(emptyxpm  empty.osm pbf,add_metadata=false                           empty-nometadata.osm.pbf)
check_formats(emptyxpdm empty.osm pbf,pbf_dense_nodes=false,add_metadata=false     empty-nodensenodes-nometadata.osm.pbf)

check_formats(emptypx empty.osm.pbf xml empty.osm)
check_formats(emptypo empty.osm.pbf opl empty.osm.opl)
check_formats(emptypp empty.osm.pbf pbf empty.osm.pbf)

check_formats(emptypxd empty-nodensenodes.osm.pbf xml empty.osm)
check_formats(emptypod empty-nodensenodes.osm.pbf opl empty.osm.opl)
check_formats(emptyppd empty-nodensenodes.osm.pbf pbf empty.osm.pbf)

check_formats(emptypxc empty-nocompression.osm.pbf xml empty.osm)
check_formats(emptypoc empty-nocompression.osm.pbf opl empty.osm.opl)
check_formats(emptyppc empty-nocompression.osm.pbf pbf empty.osm.pbf)

# normal file
check_formats(f1xx   f1.osm xml f1.osm)
check_formats(f1xo   f1.osm opl f1.osm.opl)
check_formats(f1xp   f1.osm pbf                                          f1.osm.pbf)
check_formats(f1xpd  f1.osm pbf,pbf_dense_nodes=false                    f1-nodensenodes.osm.pbf)
check_formats(f1xpc  f1.osm pbf,pbf_compression=none                     f1-nocompression.osm.pbf)
check_formats(f1xpm  f1.osm pbf,add_metadata=false                       f1-nometadata.osm.pbf)
check_formats(f1xpdm f1.osm pbf,pbf_dense_nodes=false,add_metadata=false f1-nodensenodes-nometadata.osm.pbf)

check_formats(f1px f1.osm.pbf xml f1.osm)
check_formats(f1po f1.osm.pbf opl f1.osm.opl)
check_formats(f1pp f1.osm.pbf pbf f1.osm.pbf)

check_formats(f1pxd f1-nodensenodes.osm.pbf xml f1.osm)
check_formats(f1pod f1-nodensenodes.osm.pbf opl f1.osm.opl)
check_formats(f1ppd f1-nodensenodes.osm.pbf pbf f1.osm.pbf)

check_formats(f1pxc f1-nocompression.osm.pbf xml f1.osm)
check_formats(f1poc f1-nocompression.osm.pbf opl f1.osm.opl)
check_formats(f1ppc f1-nocompression.osm.pbf pbf f1.osm.pbf)


#-----------------------------------------------------------------------------

=== test/merge/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - merge
#
#-----------------------------------------------------------------------------

function(check_merge1 _name _input1 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1}" "merge/${_output}")
endfunction()

function(check_merge2 _name _input1 _input2 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1} merge/${_input2}" "merge/${_output}")
endfunction()

function(check_merge3 _name _input1 _input2 _input3 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1} merge/${_input2} merge/${_input3}" "merge/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_merge1(i1 input1.osm output1.osm)
check_merge2(i2f input1.osm input2.osm output2.osm)
check_merge2(i2r input2.osm input1.osm output2.osm)
check_merge3(i3f input1.osm input2.osm input3.osm output3.osm)

# If both input files do not have timestamp attributes
check_merge2(i2f-only-version input1-only-version.osm input2-only-version.osm output2-12-only-version.osm)
check_merge2(i2r-only-version input2-only-version.osm input1-only-version.osm output2-12-only-version.osm)

do_test(merge-unsorted-types-wn "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-types-wn.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "must be nodes, then ways, then relations")
do_test(merge-unsorted-types-nrw "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-types-nrw.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "must be nodes, then ways, then relations")
do_test(merge-unsorted-ids-n "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-ids-n.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "smaller ids must come first")
do_test(merge-unsorted-ids-w "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-ids-w.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "smaller ids must come first")
do_test(merge-unsorted-versions-21 "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-versions-21.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "smaller version must come first")
do_test(merge-unsorted-versions-132 "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-versions-132.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "smaller version must come first")
do_test(merge-unsorted-versions-133 "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/unsorted-versions-133.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "with same version.")

do_test(merge-same-ids-warning "osmium merge ${PROJECT_SOURCE_DIR}/test/merge/same-ids.osm ${PROJECT_SOURCE_DIR}/test/merge/empty.osm -f opl" "Multiple objects with same id")
check_output(merge merge-same-ids-h "merge --generator=test --with-history -f osm merge/same-ids.osm merge/empty.osm" "merge/output-same-ids.osm")

#-----------------------------------------------------------------------------

=== test/removeid/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - removeid
#
#-----------------------------------------------------------------------------

function(check_removeid _name _input _ids _output)
    check_output(removeid ${_name} "removeid --generator=test --output-header=xml_josm_upload=false -f osm removeid/${_input} ${_ids}" "removeid/${_output}")
endfunction()

function(check_removeid_file _name _file _input _output)
    check_output(removeid ${_name} "removeid --generator=test --output-header=xml_josm_upload=false -i removeid/${_file} -f osm removeid/${_input}" "removeid/${_output}")
endfunction()

check_removeid(n11n12 input.osm n11,n12 output-n11n12.osm)
check_removeid(n10w21 input.osm 10,w21 output-n10w21.osm)
check_removeid(r30 input.osm r30 output-r30.osm)

check_removeid_file(n12w20 n12w20.ids input.osm output-n12w20.osm)

#-----------------------------------------------------------------------------

=== test/tags-filter/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - tags-filter
#
#-----------------------------------------------------------------------------

function(check_tags_filter _name _flags _input _expressions _output)
    check_output(tags-filter ${_name} "tags-filter --generator=test --output-header=xml_josm_upload=false -f osm ${_flags} tags-filter/${_input} ${_expressions}" "tags-filter/${_output}")
endfunction()

check_tags_filter(node        ""      input.osm n/amenity output-amenity.osm)
check_tags_filter(node-R      "-R"    input.osm n/amenity output-amenity.osm)

check_tags_filter(highway-R   "-R"    input.osm w/highway output-highway-R.osm)
check_tags_filter(note-R      "-R"    input.osm note output-note-R.osm)

check_tags_filter(note-iR     "-i -R" input.osm note output-note-iR.osm)

check_tags_filter(highway     ""      input.osm w/highway output-highway.osm)

check_tags_filter(highway-i   "-i"    input.osm w/highway output-highway-i.osm)

check_tags_filter(highway-n-i "-i"    input-nodes.osm w/highway output-nodes-highway-i.osm)

check_tags_filter(note-rel    ""      input.osm r/note output-note-rel.osm)

check_tags_filter(highway-t   "-t"    input.osm w/highway output-highway-t.osm)
check_tags_filter(highway-it  "-i -t" input.osm w/highway output-highway-it.osm)
check_tags_filter(note-rel-t  "-t"    input.osm r/note output-note-rel-t.osm)


check_tags_filter(site-1     ""   input-site.osm r/site=1 output-site-1.osm)
check_tags_filter(site-2     ""   input-site.osm r/site=2 output-site-2.osm)
check_tags_filter(site-R     "-R" input-site.osm r/site=2 output-site-R.osm)
check_tags_filter(site-R-all "-R" input-site.osm r/site output-site-R-all.osm)
check_tags_filter(site-t     "-t" input-site.osm r/site output-site-t.osm)

#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.14.0-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright file.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 07 Feb 2022 17:55:17 +0100

=== debian/control ===
Source: osmium-tool
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-dev,
               libboost-program-options-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.16.0),
               pandoc,
               zlib1g-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmium-tool/
Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git
Homepage: https://osmcode.org/osmium-tool/

Package: osmium-tool
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command line tool for working with OpenStreetMap data
 Osmium Tool is a multipurpose command line tool based on the Osmium library.
 .
 With the Osmium Tool you currently can:
 .
  * Get information about an OSM file
  * Convert OSM files from one format into another (supports all XML and PBF
    formats)
  * Merge and apply change files to an OSM file (with or without history)
  * Extract data from OSM history files for a given point in time or a time
    range
 .
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.

## osmium-tool 1.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 cmake_minimum_required(VERSION 3.5.0)
 
-project(osmium VERSION 1.14.0 LANGUAGES CXX C)
+project(osmium VERSION 1.15.0 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 
@@ -43,7 +43,7 @@
 find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
 include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
 
-find_package(Osmium 2.16.0 REQUIRED COMPONENTS io)
+find_package(Osmium 2.17.0 REQUIRED COMPONENTS io)
 include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})
 
 
@@ -293,7 +293,7 @@
 #
 #-----------------------------------------------------------------------------
 message(STATUS "Looking for clang-tidy")
-find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-14 clang-tidy-13 clang-tidy-12 clang-tidy-11)
+find_program(CLANG_TIDY NAMES clang-tidy clang-tidy-16 clang-tidy-15 clang-tidy-14 clang-tidy-13 clang-tidy-12 clang-tidy-11)
 
 if(CLANG_TIDY)
     message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

=== test/add-locations-to-ways/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - add-locations-to-ways
#
#-----------------------------------------------------------------------------

function(check_add_locations_to_ways _name _options _input _output)
    check_output(add-locations-to-ways ${_name} "add-locations-to-ways ${_options} --generator=test --output-header=xml_josm_upload=false --output-format=xml add-locations-to-ways/${_input}" "add-locations-to-ways/${_output}")
endfunction()

check_add_locations_to_ways(taggednodes "" input.osm output.osm)
check_add_locations_to_ways(allnodes "-n" input.osm output-n.osm)
check_add_locations_to_ways(membernodes "--keep-member-nodes" input-rel.osm output-rel.osm)


#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.15.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 25 Jan 2023 05:30:35 +0100

osmium-tool (1.15.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2, no changes.
  * Update copyright file.
  * Drop libosmium-version.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Jan 2023 15:08:28 +0100

osmium-tool (1.14.0-2) unstable; urgency=medium

  * Require at least libosmium2-dev 2.17.0.
  * Bump Standards-Version to 4.6.1, no changes.
  * Add Rules-Requires-Root to control file.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Dec 2022 14:52:13 +0100

osmium-tool (1.14.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * Require at least libosmium2-dev 2.17.0.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 13 Feb 2022 08:24:01 +0100

=== debian/control ===
--- 
+++ 
@@ -9,13 +9,14 @@
                libboost-program-options-dev,
                libbz2-dev,
                libexpat1-dev,
-               libosmium2-dev (>= 2.16.0),
+               libosmium2-dev (>= 2.17.0),
                pandoc,
                zlib1g-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmium-tool/
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git -b bullseye-backports
 Homepage: https://osmcode.org/osmium-tool/
+Rules-Requires-Root: no
 
 Package: osmium-tool
 Architecture: any

## osmium-tool 1.16.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 cmake_minimum_required(VERSION 3.5.0)
 
-project(osmium VERSION 1.15.0 LANGUAGES CXX C)
+project(osmium VERSION 1.16.0 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

=== test/changeset-filter/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - changeset-filter
#
#-----------------------------------------------------------------------------

function(check_changeset_filter _name _options _input _output)
    check_output(changeset-filter ${_name} "changeset-filter --generator=test -f osm ${_options} changeset-filter/${_input}" "changeset-filter/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_changeset_filter(cf1-no-option          ""                     input1.osm output1-all.osm)
check_changeset_filter(cf1-with-discussion    "--with-discussion"    input1.osm output-empty.osm)
check_changeset_filter(cf1-without-discussion "--without-discussion" input1.osm output1-all.osm)
check_changeset_filter(cf1-with-changes       "--with-changes"       input1.osm output1-first.osm)
check_changeset_filter(cf1-without-changes    "--without-changes"    input1.osm output1-second.osm)
check_changeset_filter(cf1-open               "--open"               input1.osm output-empty.osm)
check_changeset_filter(cf1-closed             "--closed"             input1.osm output1-all.osm)
check_changeset_filter(cf1-user               "--user=Elbert"        input1.osm output1-first.osm)
check_changeset_filter(cf1-uid                "--uid=1233268"        input1.osm output1-second.osm)

check_changeset_filter(cfe-open   "--open"   input-open.osm output-open.osm)
check_changeset_filter(cfe-closed "--closed" input-open.osm output-empty.osm)

check_changeset_filter(cf1-after01 "--after=2013-03-22T02:08:50Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-after02 "--after=2013-03-22T02:08:54Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-after03 "--after=2013-03-22T02:08:55Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-after04 "--after=2013-03-22T02:08:56Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-after05 "--after=2013-03-22T02:08:57Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-after06 "--after=2013-03-22T02:08:58Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-after07 "--after=2013-03-22T02:08:59Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after08 "--after=2013-03-22T02:09:00Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after09 "--after=2013-03-22T02:09:10Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after10 "--after=2013-03-22T02:09:11Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after11 "--after=2013-03-22T02:09:12Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after12 "--after=2013-03-22T03:09:10Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after13 "--after=2013-03-22T03:09:11Z" input1.osm output1-second.osm)
check_changeset_filter(cf1-after14 "--after=2013-03-22T03:09:12Z" input1.osm output-empty.osm)
check_changeset_filter(cf1-after15 "--after=2013-03-22T03:09:20Z" input1.osm output-empty.osm)

check_changeset_filter(cfe-after01 "--after=2013-03-22T04:20:24Z" input-open.osm output-open.osm)
check_changeset_filter(cfe-after02 "--after=2013-03-22T04:20:25Z" input-open.osm output-open.osm)
check_changeset_filter(cfe-after03 "--after=2013-03-22T04:20:26Z" input-open.osm output-open.osm)

check_changeset_filter(cf1-before01 "--before=2013-03-22T02:08:50Z" input1.osm output-empty.osm)
check_changeset_filter(cf1-before02 "--before=2013-03-22T02:08:54Z" input1.osm output-empty.osm)
check_changeset_filter(cf1-before03 "--before=2013-03-22T02:08:55Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before04 "--before=2013-03-22T02:08:56Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before05 "--before=2013-03-22T02:08:57Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before06 "--before=2013-03-22T02:08:58Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before07 "--before=2013-03-22T02:08:59Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before08 "--before=2013-03-22T02:09:00Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before09 "--before=2013-03-22T02:09:10Z" input1.osm output1-first.osm)
check_changeset_filter(cf1-before10 "--before=2013-03-22T02:09:11Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-before11 "--before=2013-03-22T02:09:12Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-before12 "--before=2013-03-22T03:09:10Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-before13 "--before=2013-03-22T03:09:11Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-before14 "--before=2013-03-22T03:09:12Z" input1.osm output1-all.osm)
check_changeset_filter(cf1-before15 "--before=2013-03-22T03:09:20Z" input1.osm output1-all.osm)

check_changeset_filter(cfe-before01 "--before=2013-03-22T04:20:24Z" input-open.osm output-empty.osm)
check_changeset_filter(cfe-before02 "--before=2013-03-22T04:20:25Z" input-open.osm output-open.osm)
check_changeset_filter(cfe-before03 "--before=2013-03-22T04:20:26Z" input-open.osm output-open.osm)

check_changeset_filter(cf1-bbox01 "--bbox 120,-11,121,-10" input1.osm output1-first.osm)
check_changeset_filter(cf1-bbox02 "--bbox 130,-31,131,-30" input1.osm output-empty.osm)

#-----------------------------------------------------------------------------

=== test/export/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - export
#
#-----------------------------------------------------------------------------

function(check_export _name _options _input _output)
    check_output(export ${_name} "export ${_options} export/${_input}" "export/${_output}")
endfunction()

check_export(geojson    "-f geojson"       input.osm output.geojson)
check_export(geojsonseq "-f geojsonseq -x print_record_separator=false" input.osm output.geojsonseq)
check_export(spaten     "-f spaten"        input.osm output.spaten)

check_export(missing-node "-f geojson" input-missing-node.osm output-missing-node.geojson)
check_export(single-node-way "-f geojson" input-single-node-way.osm output-empty.geojson)

add_test(NAME export-error-node COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-missing-node.osm)
set_tests_properties(export-error-node PROPERTIES WILL_FAIL true)

add_test(NAME export-error-single-node-way COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-single-node-way.osm)
set_tests_properties(export-error-single-node-way PROPERTIES WILL_FAIL true)

check_export(invalid-area "-f geojson"  input-incomplete-relation.osm output-incomplete-relation.geojson)

add_test(NAME export-error-area COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-incomplete-relation.osm)
set_tests_properties(export-error-area PROPERTIES WILL_FAIL true)

add_test(NAME export-error-incomplete-rel COMMAND osmium export -f geojson -E ${CMAKE_SOURCE_DIR}/test/export/input-incomplete-rel-missing-way.osm)
set_tests_properties(export-error-incomplete-rel PROPERTIES WILL_FAIL true)

#-----------------------------------------------------------------------------

check_export(attributes  "-E -f text -a id" way.osm way-all.txt)

check_export(c-empty-empty-n "-E -f text --keep-untagged -c export/config-empty-empty.json" way.osm way-all-n.txt)
set_tests_properties(export-c-empty-empty-n PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-empty   "-E -f text                 -c export/config-empty-empty.json" way.osm way-all.txt)
set_tests_properties(export-c-empty-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)

check_export(c-null-null  "-E -f text -c export/config-null-null.json" way.osm way-all.txt)
check_export(c-undefined  "-E -f text -c export/config-undefined.json" way.osm way-all.txt)

check_export(c-tag-empty  "-E -f text -c export/config-tag-empty.json" way.osm way-tag-empty.txt)
set_tests_properties(export-c-tag-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-tag  "-E -f text -c export/config-empty-tag.json" way.osm way-empty-tag.txt)
set_tests_properties(export-c-empty-tag PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-tag-tag    "-E -f text -c export/config-tag-tag.json"   way.osm way-tag-tag.txt)

check_export(c-tagx-empty "-E -f text -c export/config-tagx-empty.json" way.osm way-tagx-empty.txt)
set_tests_properties(export-c-tagx-empty PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-empty-tagx "-E -f text -c export/config-empty-tagx.json" way.osm way-empty-tagx.txt)
set_tests_properties(export-c-empty-tagx PROPERTIES ENVIRONMENT osmium_cmake_stderr=ignore)
check_export(c-tagx-tagx  "-E -f text -c export/config-tagx-tagx.json"  way.osm way-tagx-tagx.txt)

check_export(c-true-true   "-E -f text -c export/config-true-true.json"   way.osm way-all.txt)
check_export(c-false-false "-E -f text -c export/config-false-false.json" way.osm way-none.txt)

check_export(c-null-tag    "-E -f text -c export/config-null-tag.json" way.osm way-null-tag.txt)
check_export(c-tag-null    "-E -f text -c export/config-tag-null.json" way.osm way-tag-null.txt)

#-----------------------------------------------------------------------------

check_export(spaten-untagged "-f spaten --keep-untagged" input.osm output-untagged.spaten)

#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.16.0-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:54:09 +0100

osmium-tool (1.16.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump debhelper compat to 13.
  * Enable Salsa CI.
  * Add architecture-is-little-endian to build depends.
    https://github.com/osmcode/osmium-tool/issues/176
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 20 Sep 2023 18:59:57 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Uploaders: Bas Couwenberg <sebastic@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: architecture-is-little-endian,
+               debhelper-compat (= 13),
                cmake,
                libboost-dev,
                libboost-program-options-dev,
@@ -14,7 +15,7 @@
                zlib1g-dev
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osmium-tool/
-Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git -b bullseye-backports
+Vcs-Git: https://salsa.debian.org/debian-gis-team/osmium-tool.git
 Homepage: https://osmcode.org/osmium-tool/
 Rules-Requires-Root: no
